ghc-lib-parser-9.12.2.20250421: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Unit.Module.ModDetails

Synopsis

- data ModDetails = ModDetails {
  - md_exports :: [AvailInfo]
  - md_types :: !TypeEnv
  - md_defaults :: !DefaultEnv
  - md_insts :: InstEnv
  - md_fam_insts :: ![FamInst]
  - md_rules :: ![CoreRule]
  - md_anns :: ![Annotation]
  - md_complete_matches :: CompleteMatches
  }
- emptyModDetails :: ModDetails

# Documentation

data ModDetails Source #

The `ModDetails` is essentially a cache for information in the `ModIface` for home modules only. Information relating to packages will be loaded into global environments in `ExternalPackageState`.

Constructors

ModDetails |

Fields

- md_exports :: [AvailInfo]
- md_types :: !TypeEnv

  Local type environment for this particular module Includes Ids, TyCons, PatSyns

- md_defaults :: !DefaultEnv

  default declarations exported by this module

- md_insts :: InstEnv

  `DFunId`s for the instances in this module

- md_fam_insts :: ![FamInst]
- md_rules :: ![CoreRule]

  Domain may include `Id`s from other modules

- md_anns :: ![Annotation]

  Annotations present in this module: currently they only annotate things also declared in this module

- md_complete_matches :: CompleteMatches

  Complete match pragmas for this module

emptyModDetails :: ModDetails Source #

Constructs an empty ModDetails